// IniReadWrite.cpp : R\[ AvP[Vp̃Gg |Cg̒`
//

#include "stdafx.h"
#include "IniReadWrite.h"
#include "ProfileManager.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// B̃AvP[V IuWFNg

CWinApp theApp;

using namespace std;

class CMyProfileReadWrite : public CProfileManager {
protected:
	// INI 
	virtual void Init();
	// INI ǂݏ
	virtual void ProfileRW();

public:
	struct MySection1_ {
		int Key1;
		CString Key2;
		double Key3;
	} MySection1;
	struct MySection2_ {
		int Key1;
		CString Key2;
		double Key3;
	} MySection2;
};

// INI 
void CMyProfileReadWrite::Init()
{
	// ftHglݒ肷
	// MySection1
	MySection1.Key1 = 11;
	MySection1.Key2 = _T("Value22");
	MySection1.Key3 = 33.3;

	// MySection2
	MySection2.Key1 = 111;
	MySection2.Key2 = _T("Value222");
	MySection2.Key3 = 333.33;
}

// INI ǂݏ
void CMyProfileReadWrite::ProfileRW()
{
	// MySection1
	ItemRW(_T("MySection1"), _T("Key1"), MySection1.Key1);
	ItemRW(_T("MySection1"), _T("Key2"), MySection1.Key2);
	ItemRW(_T("MySection1"), _T("Key3"), MySection1.Key3);

	// MySection2
	ItemRW(_T("MySection2"), _T("Key1"), MySection2.Key1);
	ItemRW(_T("MySection2"), _T("Key2"), MySection2.Key2);
	ItemRW(_T("MySection2"), _T("Key3"), MySection2.Key3);
}

int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	int nRetCode = 0;

	// MFC ̏яs̃G[̏o
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
	{
		// TODO: KvɉăG[ R[hύXĂB
		cerr << _T("Fatal Error: MFC initialization failed") << endl;
		nRetCode = 1;
	}
	else
	{
		// TODO: ̈ʒuɃAvP[V̓LqĂB

		// INI t@C̃pX𓾂B
		TCHAR modulePath[4096];
		DWORD length = GetModuleFileName(AfxGetInstanceHandle(), modulePath, sizeof(modulePath));
		modulePath[length] = _T('\0');
		TCHAR *wp = _tcsrchr(modulePath, _T('\\'));
		if (wp) {
			*wp = _T('\0');
		}
		CString filepath;
		filepath.Format(_T("%s\\%s"), modulePath, _T("MyProfile.ini"));

		// INI t@CǂށB
		CMyProfileReadWrite myProfile;
		myProfile.Load(filepath);

		// INI t@C̓e\B

		// MySection1
		TRACE(_T("MySection1.Key1: [%d]\n"), myProfile.MySection1.Key1);
		TRACE(_T("MySection1.Key2: [%s]\n"), myProfile.MySection1.Key2);
		TRACE(_T("MySection1.Key3: [%f]\n"), myProfile.MySection1.Key3);

		// MySection2
		TRACE(_T("MySection2.Key1: [%d]\n"), myProfile.MySection2.Key1);
		TRACE(_T("MySection2.Key2: [%s]\n"), myProfile.MySection2.Key2);
		TRACE(_T("MySection2.Key3: [%f]\n"), myProfile.MySection2.Key3);

		// INI t@C̒lݒ肷B
		++myProfile.MySection1.Key1;
		myProfile.MySection1.Key2 = _T("ق");
		myProfile.MySection1.Key3 = 1.23;

		myProfile.MySection2.Key1 = 999;
		myProfile.MySection2.Key2 += _T("");
		myProfile.MySection2.Key3 *= 3;

		// INI t@CɏB
		myProfile.Save();
	}

	return nRetCode;
}


