#if !defined(AFX_PROFILEMANAGER_H__27C8D99B_BACC_4C6F_8547_8F06D8D2CB8C__INCLUDED_)
#define AFX_PROFILEMANAGER_H__27C8D99B_BACC_4C6F_8547_8F06D8D2CB8C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// INI t@C̓ǂݏ
/////////////////////////////////////////////////////////////////////////////

class CProfileManager
{
public:
	// RXgN^
	CProfileManager();
	// fXgN^
	virtual ~CProfileManager();
	// INI [h
	void Load(CString filepath);
	// INI Z[u
	void Save();

protected:
	// X̒lǂݏ
	template <class T>
	void ItemRW(CString section, CString key, T& value) {
		if (m_isWrite) {
			WriteItem(section, key, value);
		} else {
			ReadItem(section, key, value, value);
		}
	}

private:
	// lǂ(CString p)
	void ReadItem(CString section, CString key, CString& value, CString defaultValue);
	// lǂ(int p)
	void ReadItem(CString section, CString key, int& value, int defaultValue);
	// lǂ(double p)
	void ReadItem(CString section, CString key, double& value, double defaultValue);
	// l(CString p)
	void WriteItem(CString section, CString key, CString value);
	// l(int p)
	void WriteItem(CString section, CString key, int value);
	// l(double p)
	void WriteItem(CString section, CString key, double value);

private:
	// INI t@C̃pX
	CString m_filePath;
	// ǂݏtO
	BOOL m_isWrite;

protected:
	// INI 
	virtual void Init() = 0;
	// INI ǂݏ
	virtual void ProfileRW() = 0;
};

#endif // !defined(AFX_PROFILEMANAGER_H__27C8D99B_BACC_4C6F_8547_8F06D8D2CB8C__INCLUDED_)
