#include "stdafx.h"
#include "ProfileManager.h"

/////////////////////////////////////////////////////////////////////////////
// INI t@C̓ǂݏ
/////////////////////////////////////////////////////////////////////////////

//---------------------------------------------------------------------------
// RXgN^
//---------------------------------------------------------------------------

CProfileManager::CProfileManager() :
	m_isWrite(FALSE)
{
}

//---------------------------------------------------------------------------
// fXgN^
//---------------------------------------------------------------------------

CProfileManager::~CProfileManager()
{
}

//---------------------------------------------------------------------------
// INI [h
//---------------------------------------------------------------------------

void CProfileManager::Load(CString filepath)
{
	m_filePath = filepath;
	m_isWrite = FALSE;

	Init();
	ProfileRW();
}

//---------------------------------------------------------------------------
// INI Z[u
//---------------------------------------------------------------------------

void CProfileManager::Save()
{
	m_isWrite = TRUE;

	ProfileRW();
}

//---------------------------------------------------------------------------
// lǂ(CString p)
//---------------------------------------------------------------------------

void CProfileManager::ReadItem(CString section, CString key, CString& value, CString defaultValue)
{
	TCHAR buffer[1024];
	buffer[0] = _T('\0');

	GetPrivateProfileString(section, key, defaultValue, buffer, sizeof(buffer)/sizeof(TCHAR), m_filePath);
	value = buffer;
}

//---------------------------------------------------------------------------
// lǂ(int p)
//---------------------------------------------------------------------------

void CProfileManager::ReadItem(CString section, CString key, int& value, int defaultValue)
{
	value = GetPrivateProfileInt(section, key, defaultValue, m_filePath);
}

//---------------------------------------------------------------------------
// lǂ(double p)
//---------------------------------------------------------------------------

void CProfileManager::ReadItem(CString section, CString key, double& value, double defaultValue)
{
	CString strDefaultValue;
	strDefaultValue.Format(_T("%f"), defaultValue);

	CString strValue;
	ReadItem(section, key, strValue, strDefaultValue);
	TCHAR *pendp;
	value = _tcstod(strValue, &pendp);
}

//---------------------------------------------------------------------------
// l(CString p)
//---------------------------------------------------------------------------

void CProfileManager::WriteItem(CString section, CString key, CString value)
{
	WritePrivateProfileString(section, key, value, m_filePath);
}

//---------------------------------------------------------------------------
// l(int p)
//---------------------------------------------------------------------------

void CProfileManager::WriteItem(CString section, CString key, int value)
{
	CString strValue;
	strValue.Format(_T("%d"), value);
	WritePrivateProfileString(section, key, strValue, m_filePath);
}

//---------------------------------------------------------------------------
// l(double p)
//---------------------------------------------------------------------------

void CProfileManager::WriteItem(CString section, CString key, double value)
{
	CString strValue;
	strValue.Format(_T("%f"), value);
	WritePrivateProfileString(section, key, strValue, m_filePath);
}
